Globalization in EJ2 JavaScript TimePicker

21 Aug 202615 minutes to read

Globalization is the combination of internalization and localization. You can adapt the component to various languages by parsing and formatting the date or number internationalization, and also add culture specific customization and translation to the text localization.

By default, the time format and meridian names are specific to the American English culture. It utilizes the Essential® JavaScript 2 Internationalization package to parse and format the date object based on the culture by using the official UNICODE CLDR JSON data. It provides the loadCldr method to load culture specific CLDR JSON data. To use a different culture other than English, follow the steps below:

  • Install the CLDR-Data package by using the following command (installs all the CLDR JSON data). To know more about CLDR-Data refer to the CLDR-Data link.
npm install cldr-data --save

Once the package is installed, you can find the culture specific JSON data under the location /node_modules/cldr-data.

  • Import the installed CLDR JSON data into the app.ts file. To import JSON data, install the JSON plugin loader. Here, The systemJS JSON plugin loader is used.
npm install systemjs-plugin-json --save-dev
  • After installation, configure the system.config.js configuration settings as given below to map the systemjs-plugin-json loader.
System.config({
    paths: {
        'npm:': './node_modules/',
        'syncfusion:': 'npm:@syncfusion/'
    },
    map: {
        app: 'app',

        //Syncfusion packages mapping
        "@syncfusion/ej2-base": "syncfusion:ej2-base/dist/ej2-base.umd.min.js",
        "@syncfusion/ej2-data": "syncfusion:ej2-data/dist/ej2-data.umd.min.js",
        "@syncfusion/ej2-inputs": "syncfusion:ej2-inputs/dist/ej2-inputs.umd.min.js",
        "@syncfusion/ej2-splitbuttons": "syncfusion:ej2-splitbuttons/dist/ej2-splitbuttons.umd.min.js",
        "@syncfusion/ej2-buttons": "syncfusion:ej2-buttons/dist/ej2-buttons.umd.min.js",
        "@syncfusion/ej2-lists": "syncfusion:ej2-lists/dist/ej2-lists.umd.min.js",
        "@syncfusion/ej2-navigations": "syncfusion:ej2-navigations/dist/ej2-navigations.umd.min.js",
        "@syncfusion/ej2-popups": "syncfusion:ej2-popups/dist/ej2-popups.umd.min.js",
        "@syncfusion/ej2-charts": "syncfusion:ej2-charts/dist/ej2-charts.umd.min.js",
        "@syncfusion/ej2-calendars": "syncfusion:ej2-calendars/dist/ej2-calendars.umd.min.js",
        "@syncfusion/ej2-grids": "syncfusion:ej2-grids/dist/ej2-grids.umd.min.js",
        "cldr-data": 'npm:cldr-data',
        "plugin-json": "npm:systemjs-plugin-json/json.js"
    },
    meta: {
        '*.json': { loader: 'plugin-json' }
    },
    packages: {
        'app': { main: 'app', defaultExtension: 'js' },
        'cldr-data': { main: 'index.js', defaultExtension: 'js' }
    }
});

System.import('app');
  • Use the loadCldr method to load the culture specific CLDR JSON data from the installed location to app.ts file.

  • TimePicker displayed Sunday as the first day of week based on default culture (“en-US”). If you want to display the TimePicker with loaded culture’s first day of week, you need to import weekdata.json file from the cldr-data/suppemental as given in the code example.

import { loadCldr } from '@syncfusion/ej2-base';

declare var require: any;

loadCldr(
    require('cldr-data/supplemental/numberingSystems.json'),
    require('cldr-data/main/de/ca-gregorian.json'),
    require('cldr-data/main/de/numbers.json'),
    require('cldr-data/supplemental/weekdata.json') // To load the culture based first day of week
);
  • Before changing to a culture other than English, ensure that the locale text for the concerned culture is loaded through L10n.load method.
//Load the L10n from ej2-base
import { L10n } from '@syncfusion/ej2-base';

//load the locale object to set the localized placeholder value
L10n.load({
    'de': {
        'timepicker': { placeholder: 'Wählen Sie Zeit' }
    }
});
  • Set the culture by using the locale property. In the following code example, the TimePicker component is initialized in German culture with corresponding localized text.
import { TimePicker } from '@syncfusion/ej2-calendars';
//Load the L10n from ej2-base
import { L10n, loadCldr } from '@syncfusion/ej2-base';
import { enableRipple } from '@syncfusion/ej2-base';

//enable ripple style
enableRipple(true);

declare var require: any;

loadCldr(
    require('cldr-data/supplemental/numberingSystems.json'),
    require('cldr-data/main/de/ca-gregorian.json'),
    require('cldr-data/main/de/numbers.json')
);

//load the locale object to set the localized placeholder value
L10n.load({
    'de': {
        'timepicker': { placeholder: 'Wählen Sie Zeit' }
    }
});

// creates the timepicker with German culture.
let timeObject: TimePicker = new TimePicker({
    locale:'de',
    value: new Date()
});
timeObject.appendTo('#element');

The following example demonstrates the TimePicker in German culture.

ej.base.enableRipple(true);
  
  var L10n = ej.base.L10n;
  
L10n.load({
    'de': {
        'timepicker': { placeholder: 'Wählen Sie Zeit' }
    }
});

     loadCultureFiles('de');
       var timepicker = new ej.calendars.TimePicker({
       locale: 'de'
    });
    timepicker.appendTo('#element');

  function loadCultureFiles(name) {
        var files = ['ca-gregorian.json', 'numbers.json', 'timeZoneNames.json'];
        var loader = ej.base.loadCldr;
        var loadCulture = function (prop) {
            var val, ajax;
            ajax = new ej.base.Ajax('https://ej2.syncfusion.com/javascript/demos/' + 'src/common/cldr-data/main/' + name + '/' + files[prop], 'GET', false);
            ajax.onSuccess = function (value) {
                val = value;
            };
            ajax.send();
            loader(JSON.parse(val));
        };
        for (var prop = 0; prop < files.length; prop++) {
            loadCulture(prop);
        }
    }
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2 TimePicker control</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <!--style reference from the TimePicker component-->
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-lists/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-calendars/styles/material.css" rel="stylesheet">
    <link href="style.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <input id="element" type="text">
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Right-To-Left

The TimePicker supports RTL (right-to-left) functionality for languages like Arabic and Hebrew to displays the text in the right-to-left direction. Use enableRtl property to set the RTL direction.

The code example demonstrates the TimePicker component in Arabic culture. It also explains how to set localized text to the placeholder using L10n.load method.

import { TimePicker } from '@syncfusion/ej2-calendars';
//Load the L10n from ej2-base
import { L10n, loadCldr } from '@syncfusion/ej2-base';
import { enableRipple } from '@syncfusion/ej2-base';

//enable ripple style
enableRipple(true);

declare var require: any;

loadCldr(
    require('cldr-data/supplemental/numberingSystems.json'),
    require('cldr-data/main/ar/ca-gregorian.json'),
    require('cldr-data/main/ar/numbers.json')
);

//load the locale object to set the localized placeholder value
L10n.load({
    'ar': {
        'timepicker': { placeholder: 'حدد الوقت' }
    }
});

// creates the timepicker with Arabic culture.
let timeObject: TimePicker = new TimePicker({
    //sets the locale
    locale: 'ar',
    value: new Date(),
    //sets the enableRtl
    enableRtl: true
});
timeObject.appendTo('#element');

The following example demonstrates TimePicker in Arabic culture with right-to-left direction.

ej.base.enableRipple(true);        
     loadCultureFiles('ar');
     var L10n=ej.base.L10n;
   
     L10n.load({
    'ar': {
        'timepicker': { placeholder: 'حدد الوقت' }
    }
});
   var timepicker = new ej.calendars.TimePicker({
       locale: 'ar',enableRtl:true
    });
    timepicker.appendTo('#element');
 
function loadCultureFiles(name) {
        var files = ['ca-gregorian.json', 'numbers.json', 'timeZoneNames.json'];
        if (name === 'ar') {
            files.push('numberingSystems.json');
        }
        var loader = ej.base.loadCldr;
        var loadCulture = function (prop) {
            var val, ajax;
            if (name === 'ar' && prop === files.length - 1) {
                ajax = new ej.base.Ajax('https://ej2.syncfusion.com/javascript/demos/src/common/cldr-data/supplemental/' + files[prop], 'GET', false);
            } else {
                ajax = new ej.base.Ajax('https://ej2.syncfusion.com/javascript/demos/src/common/cldr-data/main/' + name + '/' + files[prop], 'GET', false);
            }
            ajax.onSuccess = function (value) {
                val = value;
            };
            ajax.send();
            loader(JSON.parse(val));
        };
        for (var prop = 0; prop < files.length; prop++) {
            loadCulture(prop);
        }
    }
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2 TimePicker control</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <!--style reference from the TimePicker component-->
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-lists/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-calendars/styles/material.css" rel="stylesheet">
    <link href="style.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <input id="element" type="text">
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Globalization is the combination of internationalization and localization. You can adapt the component to
various languages by means of parsing and formatting the date or
number internationalization
, and also add
culture specific customization and translation to the text
localization
.
By default, TimePicker time format and meridian names are specific to the American English
culture. It utilizes the
Essential JavaScript 2 Internationalization
package to parse and format the date object based on the culture by using the official UNICODE CLDR
JSON data. It provides the loadCldr
method to load culture specific CLDR JSON data. To go with the different culture other
than English
, follow the steps below.
CLDR-Data
package by using the following command (it installs all the CLDR JSON data). To
known more about CLDR-Data refer the CLDR-Data
link.npm install cldr-data --save
Once the package is installed, you can find the culture
specific JSON data under the location \node_modules\cldr-data
.
Import the installed CLDR JSON data into the app.ts
file.
Use the loadCldr
method
to load the culture specific CLDR JSON data
from the installed location to app.ts
file.
TimePicker displayed Sunday
as the first day of week based on default culture (“en-US”). If you want to display the TimePicker with loaded culture’s first day of week, you need to import weekdata.json
file from the cldr-data/suppemental
as given in the code example.
import { loadCldr } from '@syncfusion/ej2-base';
import { loadCldr } from "@syncfusion/ej2-base";
import * as gregorian from 'cldr-data/main/de/ca-gregorian.json';
import * as numbers from 'cldr-data/main/de/numbers.json';
import * as numberingSystems from 'cldr-data/supplemental/numberingSystems.json';
loadCldr(numberingSystems, gregorian, numbers);
if you are facing the error
/node_modules/cldr-data/main/de/*.json (1,1): unused expression, expected an assignment or function call
when you are adding the json files to render the culture sample, then add the below configuration in yourtslint.json
file
"linterOptions": {
"exclude": [
"*.json",
"**/*.json"
]
}
English
, ensure that locale text for the concerned culture is loaded through load
method of L10n
class.//Load the L10n, loadCldr from ej2-base
import { loadCldr, L10n } from '@syncfusion/ej2-base';
//load the locale object to set the localized placeholder value
L10n.load({
'de': {
'timepicker': { placeholder: 'Wählen Sie Zeit'}
}
});
locale
property. In the following code example, the DateTimePicker is initialized
in German
culture with
corresponding localized text.The following example demonstrates the TimePicker in German
culture.
import * as React from "react";
import * as ReactDOM from "react-dom";
//Load the L10n, loadCldr from ej2-base
import { loadCldr, L10n } from '@syncfusion/ej2-base';
//import the ripple effect
import { enableRipple } from '@syncfusion/ej2-base';
//import the timepicker
import { TimePickerComponent } from '@syncfusion/ej2-react-calendars';
// enable ripple effect
enableRipple(true);
//load the CLDR data files.
// Here we have referred local json files for preview purpose
import * as numberingSystems from './numberingSystems.json';
import * as gregorian from './ca-gregorian.json';
import * as numbers from './numbers.json';
loadCldr(numberingSystems, gregorian, numbers);
L10n.load({
'de': {
'timepicker': { placeholder: 'Wählen Sie Zeit' }
}
});
//import the timepickercomponent
class App extends React.Component<{}, {}> {
render() {
return <TimePickerComponent id="time" locale='de'/>
}
};
ReactDOM.render(<App />, document.getElementById('timer'));
<!DOCTYPE html>
<html lang="en">
<head>
<title>Syncfusion React TimePicker</title>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<meta name="description" content="Essential JS 2 for React Components" />
<meta name="author" content="Syncfusion" />
<link href="//cdn.syncfusion.com/ej2/ej2-base/styles/material.css" rel="stylesheet" />
<link href="//cdn.syncfusion.com/ej2/ej2-react-inputs/styles/material.css" rel="stylesheet" />
<link href="//cdn.syncfusion.com/ej2/ej2-react-popups/styles/material.css" rel="stylesheet" />
<link href="//cdn.syncfusion.com/ej2/ej2-react-lists/styles/material.css" rel="stylesheet" />
<link href="//cdn.syncfusion.com/ej2/ej2-react-calendars/styles/material.css" rel="stylesheet" />
<link href="style.css" rel="stylesheet" />
<link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
<script src="systemjs.config.js"></script>
</head>
<body>
<div id='timer'>
<div id='loader'>Loading....</div>
</div>
</body>
</html>
The TimePicker supports RTL (right-to-left) functionality for languages like Arabic and Hebrew to displays the
text in the right-to-left direction. Use
enableRtl
property to set the RTL direction.
The code example demonstrates the TimePicker component in Arabic
culture, also explains how to set the localized text to
the placeholder using L10n.load
method.
import * as React from "react";
import * as ReactDOM from "react-dom";
//Load the L10n, loadCldr from ej2-base
import { loadCldr, L10n } from '@syncfusion/ej2-base';
//import the ripple effect
import { enableRipple } from '@syncfusion/ej2-base';
//import the timepicker
import { TimePickerComponent } from '@syncfusion/ej2-react-calendars';
// enable ripple effect
enableRipple(true);
//load the CLDR data files.
// Here we have referred local json files for preview purpose
import * as numberingSystems from './numberingSystems.json';
import * as gregorian from './ca-gregorian.json';
import * as numbers from './numbers.json';
loadCldr(numberingSystems, gregorian, numbers);
L10n.load({
'ar': {
'timepicker': { placeholder: 'حدد الوقت' }
}
});
//import the timepickercomponent
class App extends React.Component<{}, {}> {
private rtl:boolean=true;
render() {
return <TimePickerComponent id="time" locale='ar' enableRtl={this.rtl} />
}
};
ReactDOM.render(<App />, document.getElementById('timer'));
<!DOCTYPE html>
<html lang="en">
<head>
<title>Essential JS 2 TimePicker control</title>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<meta name="description" content="Typescript UI Controls" />
<meta name="author" content="Syncfusion" />
<!--style reference from the TimePicker component-->
<link href="//cdn.syncfusion.com/ej2/ej2-base/styles/material.css" rel="stylesheet" />
<link href="//cdn.syncfusion.com/ej2/ej2-react-inputs/styles/material.css" rel="stylesheet" />
<link href="//cdn.syncfusion.com/ej2/ej2-react-popups/styles/material.css" rel="stylesheet" />
<link href="//cdn.syncfusion.com/ej2/ej2-react-lists/styles/material.css" rel="stylesheet" />
<link href="//cdn.syncfusion.com/ej2/ej2-react-calendars/styles/material.css" rel="stylesheet" />
<link href="style.css" rel="stylesheet" />
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
<script src="systemjs.config.js"></script>
</head>
<body>
<div id='timer'>
<div id='loader'>Loading....</div>
</div>
</body>
</html>

Globalization in Vue TimePicker

21 Aug 20268 minutes to read

Globalization is the combination of internalization and localization. You can adapt the component to various languages by parsing and formatting the date or number internationalization, and also add culture specific customization and translation to the text localization.

By default, the time format and meridian names are specific to the American English culture. It utilizes the Essential® JavaScript 2 Internationalization package to parse and format the date object based on the culture by using the official UNICODE CLDR JSON data. It provides the loadCldr method to load culture specific CLDR JSON data. To use a different culture other than English, follow the steps below:

  • Install the CLDR-Data package by using the following command (installs all the CLDR JSON data). To know more about CLDR-Data refer to the CLDR-Data link.

    npm install cldr-data --save
    

Once the package is installed, you can find the culture specific JSON data under the location /node_modules/cldr-data.

  • Import the installed CLDR JSON data into the app.vue file.

  • Use the loadCldr
    method to load the culture specific CLDR JSON data from the installed location to app.vue file.

  • TimePicker displayed Sunday as the first day of week based on default culture (“en-US”). If you want to display the TimePicker with loaded culture’s first day of week, you need to import weekdata.json file from the cldr-data/suppemental as given in the code example.

//Load the loadCldr from ej2-base
import { loadCldr } from '@syncfusion/ej2-base';

import * as numberingSystems from 'cldr-data/supplemental/numberingSystems.json';
import * as gregorian from 'cldr-data/main/de/ca-gregorian.json';
import * as numbers from 'cldr-data/main/de/numbers.json';
import * as weekData from 'cldr-data/supplemental/weekdata.json';// To load the culture based first day of week

loadCldr(numberingSystems, gregorian, numbers, weekData);
  • Before changing to a culture other than English, ensure that the\ locale text for the concerned culture is loaded through L10n.loadmethod.
//Load the L10n from ej2-base
import { L10n } from '@syncfusion/ej2-base';

//load the locale object to set the localized placeholder value
L10n.load({
    'de': {
        'timepicker': { placeholder: 'Wählen Sie Zeit' }
    }
});
  • Set the culture by using the locale property.

The following example demonstrates the TimePicker in German culture.

<template>
  <div id="app">
    <div class='wrapper'>
      <ejs-timepicker id="timepicker" locale="de"></ejs-timepicker>
    </div>
  </div>
</template>
<script setup>

import { loadCldr, L10n } from '@syncfusion/ej2-base';
import { TimePickerComponent as EjsTimepicker } from '@syncfusion/ej2-vue-calendars';
// Here we have referred local json files for preview purpose
import * as numberingSystems from './numberingSystems.json';
import * as gregorian from './ca-gregorian.json';
import * as numbers from './numbers.json';
import { enableRipple } from '@syncfusion/ej2-base';

//enable ripple style
enableRipple(true);

loadCldr(numberingSystems, gregorian, numbers);
L10n.load({
  'de': {
    'timepicker': { placeholder: 'Wählen Sie Zeit' }
  }
});

</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/material.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material.css';
@import '../node_modules/@syncfusion/ej2-lists/styles/material.css';
@import "../node_modules/@syncfusion/ej2-vue-calendars/styles/material.css";

.wrapper {
  max-width: 250px;
  margin: 0 auto;
}
</style>
<template>
  <div id="app">
    <div class='wrapper'>
      <ejs-timepicker id="timepicker" locale="de"></ejs-timepicker>
    </div>
  </div>
</template>
<script>

import { loadCldr, L10n } from '@syncfusion/ej2-base';
import { TimePickerComponent } from '@syncfusion/ej2-vue-calendars';
// Here we have referred local json files for preview purpose
import * as numberingSystems from './numberingSystems.json';
import * as gregorian from './ca-gregorian.json';
import * as numbers from './numbers.json';
import { enableRipple } from '@syncfusion/ej2-base';

//enable ripple style
enableRipple(true);

loadCldr(numberingSystems, gregorian, numbers);
L10n.load({
  'de': {
    'timepicker': { placeholder: 'Wählen Sie Zeit' }
  }
});

export default {
  name: "App",
  components: {
    "ejs-timepicker": TimePickerComponent
  }
}
</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/material.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material.css';
@import '../node_modules/@syncfusion/ej2-lists/styles/material.css';
@import "../node_modules/@syncfusion/ej2-vue-calendars/styles/material.css";

.wrapper {
  max-width: 250px;
  margin: 0 auto;
}
</style>

Right-To-Left

The TimePicker supports RTL (right-to-left) functionality for languages like Arabic and Hebrew to displays the text in the right-to-left direction. Use enableRtl property to set the RTL direction.

The code example demonstrates the TimePicker component in Arabic culture. It also explains how to set localized text to the placeholder using L10n.load method.

`

<template>
  <div id="app">
    <div class='wrapper'>
      <ejs-timepicker id="timepicker" :locale="locale" :enableRtl="rtl"></ejs-timepicker>
    </div>
  </div>
</template>
<script setup>

import { loadCldr, L10n } from '@syncfusion/ej2-base';
import { TimePickerComponent as EjsTimepicker } from '@syncfusion/ej2-vue-calendars';
// Here we have referred local json files for preview purpose
import * as numberingSystems from './numberingSystems.json';
import * as gregorian from './ca-gregorian.json';
import * as numbers from './numbers.json';
import { enableRipple } from '@syncfusion/ej2-base';

//enable ripple style
enableRipple(true);

loadCldr(numberingSystems, gregorian, numbers);
L10n.load({
  'ar': {
    'timepicker': { placeholder: 'حدد الوقت' }
  }
});

const locale = "ar";
const rtl = true;

</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/material.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material.css';
@import '../node_modules/@syncfusion/ej2-lists/styles/material.css';
@import "../node_modules/@syncfusion/ej2-vue-calendars/styles/material.css";

.wrapper {
  max-width: 250px;
  margin: 0 auto;
}
</style>
<template>
  <div id="app">
    <div class='wrapper'>
      <ejs-timepicker id="timepicker" :locale="locale" :enableRtl="rtl"></ejs-timepicker>
    </div>
  </div>
</template>
<script>

import { loadCldr, L10n } from '@syncfusion/ej2-base';
import { TimePickerComponent } from '@syncfusion/ej2-vue-calendars';
// Here we have referred local json files for preview purpose
import * as numberingSystems from './numberingSystems.json';
import * as gregorian from './ca-gregorian.json';
import * as numbers from './numbers.json';
import { enableRipple } from '@syncfusion/ej2-base';

//enable ripple style
enableRipple(true);

loadCldr(numberingSystems, gregorian, numbers);
L10n.load({
  'ar': {
    'timepicker': { placeholder: 'حدد الوقت' }
  }
});

export default {
  name: "App",
  components: {
    "ejs-timepicker": TimePickerComponent
  },
  data() {
    return {
      locale: "ar",
      rtl: true
    }
  }
}
</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/material.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material.css';
@import '../node_modules/@syncfusion/ej2-lists/styles/material.css';
@import "../node_modules/@syncfusion/ej2-vue-calendars/styles/material.css";

.wrapper {
  max-width: 250px;
  margin: 0 auto;
}
</style>

Globalization in Angular TimePicker

14 Aug 20269 minutes to read

Globalization is the combination of internationalization and localization. You can adapt the component to various languages by means of parsing and formatting the date or number internationalization and also add culture specific customization and translation to the text localization.

By default, the time format and meridian names are specific to the American English culture. It utilizes the Essential® JavaScript 2 Internationalization package to parse and format the date object based on the culture by using the official UNICODE CLDR JSON data. It provides the loadCldr method to load culture specific CLDR JSON data. To go with the different culture other than English, follow the steps below.

  • Install the CLDR-Data package by using the following command (it installs all the CLDR JSON data.
    To known more about CLDR-Data refer the CLDR-Data link.
npm install cldr-data --save
  • Once the package installed, you can find the culture specific JSON data under the location /node_modules/cldr-data.

  • Now import the installed CLDR JSON data into the app.component.ts file.

  • Now use the loadCldr method to load the culture specific CLDR JSON data from the installed location to app.component.ts file.

  • TimePicker displayed Sunday as the first day of week based on default culture (“en-US”). If you want to display the TimePicker with loaded culture’s first day of week, you need to import weekdata.json file from the cldr-data/suppemental as given in the code example.

import { loadCldr } from '@syncfusion/ej2-base';

declare var require: any;

loadCldr(
    require('cldr-data/supplemental/numberingSystems.json'),
    require('cldr-data/main/de/ca-gregorian.json'),
    require('cldr-data/main/de/numbers.json'),
    require('cldr-data/supplemental/weekdata.json') // To load the culture based first day of week
);
  • Before changing to a culture other than English, ensure that the locale text for the concerned culture is loaded through L10n.load method.
//Load the L10n from ej2-base
import { L10n } from '@syncfusion/ej2-base';

//load the locale object to set the localized placeholder value
L10n.load({
    'de': {
        'timepicker': { placeholder: 'Wählen Sie Zeit' }
    }
});
  • Set the culture by using the locale property. In the following code example, the TimePicker component is initialized in German culture with corresponding localized text.
import { Component } from '@angular/core';
import { L10n, loadCldr } from '@syncfusion/ej2-base';
import { enableRipple } from '@syncfusion/ej2-base';

//enable ripple style
enableRipple(true);

declare var require: any;

loadCldr(
    require('cldr-data/supplemental/numberingSystems.json'),
    require('cldr-data/main/de/ca-gregorian.json'),
    require('cldr-data/main/de/numbers.json')
);

@Component({
    selector: 'app-root',
    template: `
        <ejs-timepicker [locale]='culture'></ejs-timepicker>
        `
})

export class AppComponent {
    public culture: string = 'de';
    constructor() {}
    ngOnInit(): void {
        L10n.load({
            'de': {
                'timepicker': { placeholder: 'Wählen Sie Zeit' }
            }
        });
    }
}

The following sample demonstrate the TimePicker component in German culture.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { TimePickerModule } from '@syncfusion/ej2-angular-calendars'




import { Component } from '@angular/core';
import { loadCldr, L10n } from '@syncfusion/ej2-base';
// Here we have referred local json files for preview purpose
import * as numberingSystems from './numberingSystems.json';
import * as gregorian from './ca-gregorian.json';
import * as numbers from './numbers.json';
import { enableRipple } from '@syncfusion/ej2-base';

//enable ripple style
enableRipple(true);

loadCldr(numberingSystems, gregorian, numbers);

@Component({
imports: [
        
        TimePickerModule
    ],


standalone: true,
    selector: 'app-root',
    template: `
        <ejs-timepicker [locale]='locale' [value]='dateValue'></ejs-timepicker>
        `
})

export class AppComponent {
    public locale: string = 'de';
    public dateValue: Date = new Date();
    constructor() {}
    ngOnInit(): void {
        L10n.load({
            'de': {
                'timepicker': { placeholder: 'Wählen Sie Zeit' }
            }
        });
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Right-To-Left

The TimePicker supports RTL (right-to-left) functionality for languages like Arabic and Hebrew to displays the text in the right-to-left direction. Use enableRtl property to set the RTL direction.

The following code example demonstrates the TimePicker component in Arabic culture. It also explains how to set localized text to the placeholder using L10n.load method.

import { Component } from '@angular/core';
import { L10n, loadCldr } from '@syncfusion/ej2-base';
import { enableRipple } from '@syncfusion/ej2-base';

//enable ripple style
enableRipple(true);

declare var require: any;

loadCldr(
    require('cldr-data/supplemental/numberingSystems.json'),
    require('cldr-data/main/ar/ca-gregorian.json'),
    require('cldr-data/main/ar/numbers.json')
);

@Component({
    selector: 'app-root',
    template: `
        <ejs-timepicker [locale]='culture' [enableRtl]='isRTL' [value]='dateValue'></ejs-timepicker>
        `
})

export class AppComponent {
    public culture: string = 'ar';
    public isRTL: boolean = true;
    public dateValue: Date = new Date();
    constructor() {
    }
    ngOnInit(): void {
        L10n.load({
            'ar': {
                'timepicker': { placeholder: 'حدد الوقت' }
            }
        });
    }
}

The following example demonstrates TimePicker in Arabic culture with right-to-left direction.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { TimePickerModule } from '@syncfusion/ej2-angular-calendars'




import { Component } from '@angular/core';
import { loadCldr, L10n } from '@syncfusion/ej2-base';
// Here we have referred local json files for preview purpose
import * as numberingSystems from './numberingSystems.json';
import * as gregorian from './ca-gregorian.json';
import * as numbers from './numbers.json';
import { enableRipple } from '@syncfusion/ej2-base';

//enable ripple style
enableRipple(true);

loadCldr(numberingSystems, gregorian, numbers);

@Component({
imports: [
        
        TimePickerModule
    ],


standalone: true,
    selector: 'app-root',
    template: `
        <ejs-timepicker [locale]='locale' [enableRtl]='isRTL' [value]='dateValue'></ejs-timepicker>
        `
})

export class AppComponent {
    public locale: string = 'ar';
    public isRTL: boolean = true;
    public dateValue: Date = new Date();
    constructor() {
    }
    ngOnInit(): void {
        L10n.load({
            'ar': {
                'timepicker': { placeholder: 'حدد الوقت' }
            }
        });
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));